using System;
using System.Data.Objects;
using System.Data.SqlClient;

namespace EntityContext.Core
{
    public delegate void DeleteExistingTables(ObjectContext objectContext);

    public class ContextSettings
    {
        public bool AuditEnabled;
        public string ScriptFileName;
        public bool SecurityEnabled;
        public DeleteExistingTables DeleteExistingTables;
        public string ConnectionStringName;

        public ContextSettings()
        {
            this.AuditEnabled = EntityContextConfigSection.Instance.AuditEnabled;
            this.SecurityEnabled = EntityContextConfigSection.Instance.SecurityEnabled;
            this.ScriptFileName = EntityContextConfigSection.Instance.ScriptFileName;
            this.ConnectionStringName = EntityContextConfigSection.Instance.ConnectionStringName;

            this.DeleteExistingTables = context =>
            {
                // does not work! there are FK remaining after ... NOCHECK ...?!?
                //foreach (var cmd in new List<string> {
                //    "exec sp_MSforeachtable @command1 = 'ALTER TABLE ? NOCHECK CONSTRAINT all'",
                //    "exec sp_MSforeachtable @command1 = 'DROP TABLE ?'",
                //    "exec sp_msforeachtable @command1 = 'ALTER TABLE ? WITH CHECK CHECK CONSTRAINT all'"})
                //{
                //    context.ExecuteStoreCommand(cmd);
                //}

                // BEWARE: this is a workaround, not a solution!
                var failed = true;
                var counter = 0;
                while (failed && counter < 3)
                {
                    try
                    {
                        context.ExecuteStoreCommand("exec sp_MSforeachtable @command1 = 'DROP TABLE ?'");
                        failed = false;
                    }
                    catch (SqlException)
                    {
                        counter++;
                    }
                }

                if (failed)
                {
                    throw new Exception("Cannot drop existing tables. Delete database and try again.");
                }
            };
        }
    }
}