﻿using System.Collections.Generic;
using System.Data.Entity;
using EntityContext.Core;

namespace EntityContext.Test.Entities
{
    public class Blog : EntityBase
    {
        public string Name { get; set; }

        public virtual List<Post> Posts { get; set; }

        public override void Register(DbModelBuilder builder)
        {
            base.Register<Blog>(builder, "Test.Blogs");
            builder.Entity<Blog>().Property(e => e.Name).HasMaxLength(60).IsRequired();
        }

        public override void AddConstraint(ICollection<string> constraints)
        {
            constraints.Add("ALTER TABLE [Test].[Blogs] ADD CONSTRAINT [Unique_BlogName] UNIQUE([Name])");
        }

        public override void Seed(ContextBase context)
        {
            var modelContext = context as ModelContext;
            if (modelContext != null)
            {
                modelContext.Blogs.Add(new Blog { Name = "Adam's Divine Blog"} );
            }
        }

        public override string ToString()
        {
            return string.Format("{0}: Posts: {1}", this.Name, this.Posts.Count);
        }
    }
}