﻿using System.Data.Entity;
using EntityContext.Core;

namespace EntityContext.Test.Entities
{
    public class Post : EntityBase
    {
        public string Title { get; set; }

        public string Content { get; set; }

        public virtual Blog Blog { get; set; }

        public virtual User Author { get; set; }

        public override void Register(DbModelBuilder builder)
        {
            base.Register<Post>(builder, "Test.Posts");
            builder.Entity<Post>().Property(e => e.Title).HasMaxLength(200).IsRequired();
            builder.Entity<Post>().HasRequired(e => e.Blog);
            builder.Entity<Post>().HasRequired(e => e.Author);
        }

        public override void AddConstraint(System.Collections.Generic.ICollection<string> constraints)
        {
            constraints.Add("ALTER TABLE [Test].[Posts] ADD CONSTRAINT [Unique_BlogAndTitle] UNIQUE([Title], [Blog_Id])");
        }

        public override string ToString()
        {
            return string.Format("{0} posted by {1}", this.Title, this.Author.Username);
        }
    }
}