﻿using System;
using System.Data.Entity;
using System.Linq;
using System.Text;
using EntityContext.Test.Entities;
using PasswordHash;

namespace EntityContext.Test
{
    class Program
    {
        static void Main()
        {
            try
            {
                var context = new ModelContext();
                context.Initalize();
                if (string.IsNullOrWhiteSpace(context.Settings.ScriptFileName) == false)
                {
                    Console.WriteLine("SQL Script: {0}. Remove setting to create and seed the database."
                        , context.Settings.ScriptFileName);
                }

                if (context.IsInitalized)
                {
                    Program.DoSomePosting(context);
                    Program.PrintStatistics(context);
                }

            }
            catch (Exception x)
            {
                Console.WriteLine(x);
            }

            Console.WriteLine("Press any key to continue...");
            Console.ReadKey();
        }

        private static void DoSomePosting(ModelContext context)
        {
            var blogsRepository = context.Repository<Blog>();
            var blog = blogsRepository.Single(b => b.Name.Contains("Adam"));

            var userRepository = context.Repository<User>();
            var adam = userRepository.First(u => u.FirstName == "Adam");

            var postsRepository = context.Repository<Post>();


            var iLoveEva = postsRepository.Find(p => p.Author.Id == adam.Id && p.Title == "I love Eva").SingleOrDefault();
            if (iLoveEva == null)
            {
                var content = new StringBuilder()
                    .AppendLine("Eva, my super beatuful, smart, sexy wife is loving me. ")
                    .AppendLine("And I love her so much! ")
                    .AppendLine("Thank you God you created her for me.");

                iLoveEva = new Post
                    {
                        Blog = blog,
                        Author = adam,
                        Title = "I love Eva",
                        Content = content.ToString()
                    };

                postsRepository.Insert(iLoveEva);
            }

            var evaLovesMe = postsRepository.Find(p => p.Author.Id == adam.Id && p.Title == "Does Eva love me?").SingleOrDefault();
            if (evaLovesMe == null)
            {
                var content = new StringBuilder()
                    .AppendLine("Some time ago I thought that Eva, my super beatuful, smart, sexy wife loves me. ")
                    .AppendLine("Was it really true? ")
                    .AppendLine("Some things happened lately which made me start thinking that she doesn't love me.")
                    .AppendLine("I even suspect that she does not like me, either.")
                    .AppendLine("Then who is she loving? I am the only man in the whole Universe!");

                evaLovesMe = new Post
                    {
                        Blog = blog,
                        Author = adam,
                        Title = "Does Eva love me?",
                        Content = content.ToString()
                    };

                postsRepository.Insert(evaLovesMe);
            }

            var god = userRepository.Find(u => u.FirstName == "Yehova").SingleOrDefault();
            if (god == null)
            {
                god = new User
                    {
                        Username = "God",
                        FirstName = "Yehova",
                        Email = Encrypt.SHA512("yehova@edem.com"),
                        Password = Encrypt.SHA512("123")
                    };

                userRepository.Insert(god);
                context.SaveChanges();
            }

            var sheLovesYouYeah = postsRepository.Find(p => p.Author.Id == god.Id && p.Title == "She Loves You").SingleOrDefault();
            if (sheLovesYouYeah == null)
            {
                var content = new StringBuilder()
                    .AppendLine("She loves you, yeah, yeah, yeah")
                    .AppendLine("She loves you, yeah, yeah, yeah")
                    .AppendLine("She loves you, yeah, yeah, yeah, yeah")
                    .AppendLine("")
                    .AppendLine("You think you lost your love,")
                    .AppendLine("Well, I saw her yesterday.")
                    .AppendLine("It's you she's thinking of")
                    .AppendLine("And she told me what to say.")
                    .AppendLine("...");

                sheLovesYouYeah = new Post
                    {
                        Blog = blog,
                        Author = god,
                        Title = "She Loves You",
                        Content = content.ToString()
                    };

                postsRepository.Insert(sheLovesYouYeah);
            }

            context.SaveChanges();
        }

        private static void PrintStatistics(ModelContext context)
        {
            var blogsRepository = context.Repository<Blog>();
            var blogs = blogsRepository.GetAll();
            foreach (var blog in blogs)
            {
                Console.WriteLine(blog.ToString());
            }

            var userRepository = context.Repository<User>();
            var users = userRepository.GetAll();
            foreach (var user in users)
            {
                Console.WriteLine(user.ToString());
            }

            var postsRepository = context.Repository<Post>();
            var posts = postsRepository.GetAll();
            foreach (var post in posts)
            {
                Console.WriteLine(post.ToString());
            }
        }
    }
}
